## procdump 1.1.1

=== Makefile ===
ROOT=.
CC=gcc
CFLAGS ?= -Wall
CCFLAGS=$(CFLAGS) -I ./include -pthread -std=gnu99
LIBDIR=lib
OBJDIR=obj
SRCDIR=src
INCDIR=include
BINDIR=bin
TESTDIR=tests/integration
DEPS=$(wildcard $(INCDIR)/*.h)
SRC=$(wildcard $(SRCDIR)/*.c)
TESTSRC=$(wildcard $(TESTDIR)/*.c)
OBJS=$(patsubst $(SRCDIR)/%.c, $(OBJDIR)/%.o, $(SRC))
TESTOBJS=$(patsubst $(TESTDIR)/%.c, $(OBJDIR)/%.o, $(TESTSRC))
OUT=$(BINDIR)/procdump
TESTOUT=$(BINDIR)/ProcDumpTestApplication

# Revision value from build pipeline
REVISION:=$(if $(REVISION),$(REVISION),'99999')

# installation directory
DESTDIR ?= /
INSTALLDIR=/usr/bin
MANDIR=/usr/share/man/man1

# package creation directories
BUILDDIR := $(CURDIR)/pkgbuild

# Flags to pass to debbuild/rpmbuild
PKGBUILDFLAGS := --define "_topdir $(BUILDDIR)" -bb

# Command to create the build directory structure
PKGBUILDROOT_CREATE_CMD = mkdir -p $(BUILDDIR)/DEBS $(BUILDDIR)/SDEBS $(BUILDDIR)/RPMS $(BUILDDIR)/SRPMS \
			$(BUILDDIR)/SOURCES $(BUILDDIR)/SPECS $(BUILDDIR)/BUILD $(BUILDDIR)/BUILDROOT

# package details
PKG_VERSION=1.1.1

all: clean build

build: $(OBJDIR) $(BINDIR) $(OUT) $(TESTOUT)

install:
	mkdir -p $(DESTDIR)$(INSTALLDIR)
	cp $(BINDIR)/procdump $(DESTDIR)$(INSTALLDIR)
	mkdir -p $(DESTDIR)$(MANDIR)
	cp procdump.1 $(DESTDIR)$(MANDIR)

$(OBJDIR)/%.o: $(SRCDIR)/%.c
	$(CC) -c -g -o $@ $< $(CCFLAGS)

$(OBJDIR)/%.o: $(TESTDIR)/%.c
	$(CC) -c -g -o $@ $< $(CCFLAGS)

$(OUT): $(OBJS)
	$(CC) -o $@ $^ $(CCFLAGS)

$(TESTOUT): $(TESTOBJS)
	$(CC) -o $@ $^ $(CCFLAGS)

$(OBJDIR):
	-@mkdir -p $(OBJDIR)

$(BINDIR):
	-@mkdir -p $(BINDIR)

.PHONY: clean
clean:
	-rm -rf $(OBJDIR)
	-rm -rf $(BINDIR)
	-rm -rf $(BUILDDIR)

test: build
	./tests/integration/run.sh

release: clean tarball

.PHONY: tarball
tarball:
	$(PKGBUILDROOT_CREATE_CMD)
	tar --exclude=./pkgbuild --exclude=./.git --transform 's,^\.,procdump-$(PKG_VERSION),' -czf $(BUILDDIR)/SOURCES/procdump-$(PKG_VERSION).tar.gz .
	sed -e "s/@PKG_VERSION@/$(PKG_VERSION)/g" dist/procdump.spec.in > $(BUILDDIR)/SPECS/procdump.spec

.PHONY: deb
deb: tarball
	debbuild --define='_Revision ${REVISION}' $(PKGBUILDFLAGS) $(BUILDDIR)/SPECS/procdump.spec

.PHONY: rpm
rpm: tarball
	rpmbuild --define='_Revision ${REVISION}' $(PKGBUILDFLAGS) $(BUILDDIR)/SPECS/procdump.spec

=== debian/changelog ===
procdump (1.1.1-5) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Drop override_dh_auto_{build,install}. (Closes: #977480)

  [ Anuradha Weeraman]
  * Bumped up debhelper-compat version
  * Lintian fix for hardening-no-bindnow

 -- Anuradha Weeraman <anuradha@debian.org>  Tue, 29 Dec 2020 17:07:56 +0530

procdump (1.1.1-4) unstable; urgency=medium

  * Bumped up standards version
  * Forwarded patches upstream, lintian fix

 -- Anuradha Weeraman <anuradha@debian.org>  Wed, 09 Dec 2020 17:19:29 -0500

procdump (1.1.1-3) unstable; urgency=medium

  * Set the architecture to linux-any

 -- Anuradha Weeraman <anuradha@debian.org>  Fri, 24 Jul 2020 10:30:43 -0400

procdump (1.1.1-2) unstable; urgency=medium

  * Updated Vcs-* fields after moving to Debian group on Salsa
  * Reproducibility improvements
  * Fix FTBFS due to -fno-common default in GCC 10

 -- Anuradha Weeraman <anuradha@debian.org>  Wed, 22 Jul 2020 13:49:43 -0400

procdump (1.1.1-1) unstable; urgency=medium

  * Initial release (Closes: #965243)

 -- Anuradha Weeraman <anuradha@debian.org>  Fri, 17 Jul 2020 23:39:40 -0400

=== debian/control ===
Source: procdump
Section: utils
Priority: optional
Maintainer: Anuradha Weeraman <anuradha@debian.org>
Build-Depends: debhelper-compat (= 13), zlib1g-dev
Standards-Version: 4.5.1
Homepage: https://github.com/microsoft/ProcDump-for-Linux
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/procdump
Vcs-Git: https://salsa.debian.org/debian/procdump.git

Package: procdump
Architecture: linux-any
Suggests: gdb
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Utility to create core dumps based on performance triggers
 ProcDump provides a convenient way for Linux developers to create core
 dumps of their application based on performance triggers.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=+fixfilepath
DPKG_EXPORT_BUILDFLAGS=1

include /usr/share/dpkg/buildflags.mk

# GCC10 defaults to -fno-common.
# Resolving FTBFS with -fcommon: https://gcc.gnu.org/gcc-10/porting_to.html
export CFLAGS+=$(shell dpkg-buildflags --get CFLAGS) -fcommon -Wl,-z,now
export CFLAGS+=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS+=$(shell dpkg-buildflags --get LDFLAGS)
export LC_ALL=C

%:
	dh $@

override_dh_auto_test:

=== debian/watch ===
version=4
https://github.com/microsoft/ProcDump-for-Linux/tags .*/?(\d\.\d.\d)\.tar\.gz

## procdump 1.2

=== Makefile ===
--- 
+++ 
@@ -35,7 +35,7 @@
 			$(BUILDDIR)/SOURCES $(BUILDDIR)/SPECS $(BUILDDIR)/BUILD $(BUILDDIR)/BUILDROOT
 
 # package details
-PKG_VERSION=1.1.1
+PKG_VERSION=1.2
 
 all: clean build

=== debian/changelog ===
procdump (1.2-4) unstable; urgency=medium

  * Bumped up standards version.

 -- Anuradha Weeraman <anuradha@debian.org>  Sat, 28 Jan 2023 22:28:48 +0530

procdump (1.2-3) unstable; urgency=medium

  * Bumped up standards version.

 -- Anuradha Weeraman <anuradha@debian.org>  Sat, 10 Sep 2022 14:20:51 +0530

procdump (1.2-2) unstable; urgency=high

  * Fix FTBFS with parallel builds (Closes: #994586)

 -- Anuradha Weeraman <anuradha@debian.org>  Sat, 18 Sep 2021 13:12:11 +0530

procdump (1.2-1) unstable; urgency=high

  * New upstream release
  * Updated debian patches

 -- Anuradha Weeraman <anuradha@debian.org>  Fri, 17 Sep 2021 23:12:05 +0530

procdump (1.1.1-6) unstable; urgency=high

  * Bumped up Standards Version
  * Added autopkgtest
  * Added dependency on gdb

 -- Anuradha Weeraman <anuradha@debian.org>  Wed, 08 Sep 2021 21:38:00 +0530

=== debian/control ===
Source: procdump
Section: utils
Priority: optional
Maintainer: Anuradha Weeraman <anuradha@debian.org>
Build-Depends: debhelper-compat (= 13), zlib1g-dev
Standards-Version: 4.6.2
Homepage: https://github.com/microsoft/ProcDump-for-Linux
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/procdump
Vcs-Git: https://salsa.debian.org/debian/procdump.git

Package: procdump
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}, gdb
Description: Utility to create core dumps based on performance triggers
 ProcDump provides a convenient way for Linux developers to create core
 dumps of their application based on performance triggers.

=== debian/rules ===
--- 
+++ 
@@ -13,6 +13,6 @@
 export LC_ALL=C
 
 %:
-	dh $@
+	dh $@ --no-parallel
 
 override_dh_auto_test:

## procdump 2.2

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 ROOT=.
-CC=gcc
+CC ?= gcc
 CFLAGS ?= -Wall
-CCFLAGS=$(CFLAGS) -I ./include -pthread -std=gnu99
+CCFLAGS=$(CFLAGS) -I ./include -pthread -std=gnu99 -fstack-protector-all -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 -O2 -fanalyzer -Werror
 LIBDIR=lib
 OBJDIR=obj
 SRCDIR=src
@@ -15,6 +15,12 @@
 TESTOBJS=$(patsubst $(TESTDIR)/%.c, $(OBJDIR)/%.o, $(TESTSRC))
 OUT=$(BINDIR)/procdump
 TESTOUT=$(BINDIR)/ProcDumpTestApplication
+
+# Profiler
+PROFSRCDIR=profiler/src
+PROFINCDIR=profiler/inc
+PROFCXXFLAGS ?= -DELPP_NO_DEFAULT_LOG_FILE -DELPP_THREAD_SAFE -g -pthread -shared --no-undefined -Wno-invalid-noreturn -Wno-pragma-pack -Wno-writable-strings -Wno-format-security -fPIC -fms-extensions -DHOST_64BIT -DBIT64 -DPAL_STDCPP_COMPAT -DPLATFORM_UNIX -std=c++11
+PROFCLANG=clang++
 
 # Revision value from build pipeline
 REVISION:=$(if $(REVISION),$(REVISION),'99999')
@@ -35,11 +41,11 @@
 			$(BUILDDIR)/SOURCES $(BUILDDIR)/SPECS $(BUILDDIR)/BUILD $(BUILDDIR)/BUILDROOT
 
 # package details
-PKG_VERSION=1.2
+PKG_VERSION:=$(if $(VERSION),$(VERSION),0.0.0)
 
 all: clean build
 
-build: $(OBJDIR) $(BINDIR) $(OUT) $(TESTOUT)
+build: $(OBJDIR)/ProcDumpProfiler.so $(OBJDIR) $(BINDIR) $(OUT) $(TESTOUT)
 
 install:
 	mkdir -p $(DESTDIR)$(INSTALLDIR)
@@ -47,23 +53,27 @@
 	mkdir -p $(DESTDIR)$(MANDIR)
 	cp procdump.1 $(DESTDIR)$(MANDIR)
 
-$(OBJDIR)/%.o: $(SRCDIR)/%.c
+$(OBJDIR)/ProcDumpProfiler.so: $(PROFSRCDIR)/ClassFactory.cpp $(PROFSRCDIR)/ProcDumpProfiler.cpp $(PROFSRCDIR)/dllmain.cpp $(PROFSRCDIR)/corprof_i.cpp $(PROFSRCDIR)/easylogging++.cc | $(OBJDIR)
+	$(PROFCLANG) -o $@ $(PROFCXXFLAGS) -I $(PROFINCDIR) -I $(INCDIR) $^
+	ld -r -b binary -o $(OBJDIR)/ProcDumpProfiler.o $(OBJDIR)/ProcDumpProfiler.so
+
+$(OBJDIR)/%.o: $(SRCDIR)/%.c | $(OBJDIR)
+	$(CC) -c -g -o $@ $< $(CCFLAGS) $(OPT_CCFLAGS)
+
+$(OBJDIR)/%.o: $(TESTDIR)/%.c | $(OBJDIR)
 	$(CC) -c -g -o $@ $< $(CCFLAGS)
 
-$(OBJDIR)/%.o: $(TESTDIR)/%.c
-	$(CC) -c -g -o $@ $< $(CCFLAGS)
+$(OUT): $(OBJS) | $(BINDIR) $(OBJDIR)/ProcDumpProfiler.so
+	$(CC) -o $@ $^ $(OBJDIR)/ProcDumpProfiler.o $(CCFLAGS) $(OPT_CCFLAGS)
 
-$(OUT): $(OBJS)
+$(TESTOUT): $(TESTOBJS) | $(BINDIR)
 	$(CC) -o $@ $^ $(CCFLAGS)
 
-$(TESTOUT): $(TESTOBJS)
-	$(CC) -o $@ $^ $(CCFLAGS)
+$(OBJDIR): clean
+	-mkdir -p $(OBJDIR)
 
-$(OBJDIR):
-	-@mkdir -p $(OBJDIR)
-
-$(BINDIR):
-	-@mkdir -p $(BINDIR)
+$(BINDIR): clean
+	-mkdir -p $(BINDIR)
 
 .PHONY: clean
 clean:
@@ -77,7 +87,7 @@
 release: clean tarball
 
 .PHONY: tarball
-tarball:
+tarball: clean
 	$(PKGBUILDROOT_CREATE_CMD)
 	tar --exclude=./pkgbuild --exclude=./.git --transform 's,^\.,procdump-$(PKG_VERSION),' -czf $(BUILDDIR)/SOURCES/procdump-$(PKG_VERSION).tar.gz .
 	sed -e "s/@PKG_VERSION@/$(PKG_VERSION)/g" dist/procdump.spec.in > $(BUILDDIR)/SPECS/procdump.spec

=== debian/changelog ===
procdump (2.2-4) unstable; urgency=medium

  * Team upload (salsa.d.o/debian namespace).
  * Add patch to fix arm* builds
  * Add patch to fix 32bit builds

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 28 Mar 2025 20:28:01 +0100

procdump (2.2-3) unstable; urgency=medium

  * Team upload (salsa.d.o/debian namespace).
  * Fix build with new make failing to parse tabs in Makefile
    This should print correctly the architecture now result of
    "uname -p", and let us fix build failures accordingly

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 27 Mar 2025 10:33:35 +0100

procdump (2.2-2) unstable; urgency=medium

  * Team upload (salsa.d.o/debian namespace).

  [ Benjamin Drung <bdrung@ubuntu.com> ]
  * Cherry-pick 2 upstream commits to fix build failure (LP: #2067602)
    (Closes: #1064137)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 26 Mar 2025 20:44:59 +0100

procdump (2.2-1) unstable; urgency=high

  * New upstream release.
  * NEWS file on breaking changes to the CLI.
  * Bumped up standards version.
  * Several lintian fixes.

 -- Anuradha Weeraman <anuradha@debian.org>  Sun, 15 Oct 2023 20:05:20 +0530

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: utils
 Priority: optional
 Maintainer: Anuradha Weeraman <anuradha@debian.org>
-Build-Depends: debhelper-compat (= 13), zlib1g-dev
+Build-Depends: debhelper-compat (= 13), zlib1g-dev, clang
 Standards-Version: 4.6.2
 Homepage: https://github.com/microsoft/ProcDump-for-Linux
 Rules-Requires-Root: no

=== debian/watch ===
version=4
opts="filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/procdump_$1\.tar\.gz/" \
  https://github.com/Sysinternals/ProcDump-for-Linux/tags .*/v?(\d\S+)\.tar\.gz

## procdump 3.4.1

=== CMakeLists.txt ===
#
#
#    ProcDump-for-Linux
#
#    Copyright (c) Microsoft Corporation
#
#    All rights reserved.
#
#    MIT License
#
#    Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the ""Software""), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
#
#    The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
#
#    THE SOFTWARE IS PROVIDED *AS IS*, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#
#

#################################################################################
#
# CMakeLists.txt
#
# Build script
#
#################################################################################

cmake_minimum_required(VERSION 3.10)
cmake_policy(SET CMP0048 NEW)

#
# set the project name - version is MAJOR.MINOR.PATCH.RELEASE - releases start at 1
#
if (DEFINED ENV{VERSION})
  project(ProcDumpForLinux VERSION $ENV{VERSION})
else()
  project(ProcDumpForLinux VERSION 0.0.0)
endif()

set(PROJECT_VERSION_TWEAK 0)
file(READ "dist/changelog" CHANGE_LOG)

#
# package name
#
set(PACKAGE_NAME "procdump")

#
# MAN page
#
set(PROCDUMP_COMPRESS_MAN "procdump.1.gz")

add_custom_target(procDumpManPageCompress ALL
                  DEPENDS ${PROJECT_BINARY_DIR}/${PROCDUMP_COMPRESS_MAN}
                  )

if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/${PROCDUMP_COMPRESS_MAN}
                    COMMAND gzip -9n -f -c "${CMAKE_SOURCE_DIR}/procdump.1" > ${PROJECT_BINARY_DIR}/${PROCDUMP_COMPRESS_MAN}
                    COMMENT "Compressing ProcDump man page"
                    DEPENDS "${CMAKE_SOURCE_DIR}/procdump.1"
                    )
else()
  add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/${PROCDUMP_COMPRESS_MAN}
                    COMMAND gzip -9n -f -c "${CMAKE_SOURCE_DIR}/procdump_mac.1" > ${PROJECT_BINARY_DIR}/${PROCDUMP_COMPRESS_MAN}
                    COMMENT "Compressing ProcDump man page"
                    DEPENDS "${CMAKE_SOURCE_DIR}/procdump.1"
                    )
endif()

#
# Change log
#
set(PROCDUMP_COMPRESS_CHANGELOG "changelog.gz")

add_custom_target(procDumpChangelogCompress ALL
                  DEPENDS ${PROJECT_BINARY_DIR}/${PROCDUMP_COMPRESS_CHANGELOG}
                  )

add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/${PROCDUMP_COMPRESS_CHANGELOG}
                   COMMAND cp "${CMAKE_SOURCE_DIR}/dist/changelog" ${PROJECT_BINARY_DIR} && gzip -f -c "${CMAKE_SOURCE_DIR}/dist/changelog" > ${PROJECT_BINARY_DIR}/${PROCDUMP_COMPRESS_CHANGELOG}
                   COMMENT "Compressing changelog"
                   DEPENDS "${CMAKE_SOURCE_DIR}/dist/changelog"
                  )

#
# Paths
#
set(profiler_INC ${CMAKE_SOURCE_DIR}/profiler/inc)
set(profiler_SRC ${CMAKE_SOURCE_DIR}/profiler/src)
set(procdump_INC ${CMAKE_SOURCE_DIR}/include)
set(procdump_SRC ${CMAKE_SOURCE_DIR}/src)
set(procdump_Test ${CMAKE_SOURCE_DIR}/tests/integration)
set(LD "/usr/bin/ld")
set(libbpf_SOURCE_DIR ${CMAKE_BINARY_DIR}/libbpf/src/libbpf)
set(procdump_ebpf_SOURCE_DIR ${CMAKE_SOURCE_DIR}/ebpf)
set(sym_SOURCE_DIR ${CMAKE_SOURCE_DIR}/sym)

#
# Compiler
#
set(CMAKE_CXX_COMPILER "clang++")

#
# Make procdump profiler
#
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  message(STATUS "Building for Linux")
  # Figure out which architecture we are building for
  if(CMAKE_SYSTEM_PROCESSOR STREQUAL x86_64 OR CMAKE_SYSTEM_PROCESSOR STREQUAL amd64)
    set(CLRHOSTDEF -DHOST_AMD64 -DHOST_64BIT)
    set(ARCHITECTURE "amd64")
  elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL x86 OR CMAKE_SYSTEM_PROCESSOR STREQUAL i686)
    set(CLRHOSTDEF -DHOST_X86)
  elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL armv6 OR CMAKE_SYSTEM_PROCESSOR STREQUAL armv6l)
    set(CLRHOSTDEF -DHOST_ARM -DHOST_ARMV6)
  elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL arm OR CMAKE_SYSTEM_PROCESSOR STREQUAL armv7-a)
    set(CLRHOSTDEF -DHOST_ARM)
  elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL aarch64 OR CMAKE_SYSTEM_PROCESSOR STREQUAL arm64)
    set(CLRHOSTDEF -DHOST_ARM64 -DHOST_64BIT)
    set(ARCHITECTURE "arm64")
  elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL loongarch64)
    set(CLRHOSTDEF -DHOST_LOONGARCH64 -DHOST_64BIT)
  elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL riscv64)
    set(CLRHOSTDEF -DHOST_RISCV64 -DHOST_64BIT)
  elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL s390x)
    set(CLRHOSTDEF -DHOST_S390X -DHOST_64BIT -DBIGENDIAN)
  elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL mips64)
    set(CLRHOSTDEF -DHOST_MIPS64 -DHOST_64BIT=1)
  elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL ppc64le)
    set(CLRHOSTDEF -DHOST_POWERPC64 -DHOST_64BIT)
  else()
    message(FATAL_ERROR "'${CMAKE_SYSTEM_PROCESSOR}' is an unsupported architecture.")
  endif()

  add_library(ProcDumpProfiler SHARED
              ${profiler_SRC}/ClassFactory.cpp
              ${profiler_SRC}/ProcDumpProfiler.cpp
              ${profiler_SRC}/dllmain.cpp
              ${profiler_SRC}/corprof_i.cpp
              ${profiler_SRC}/easylogging++.cc
              )

  target_compile_options(ProcDumpProfiler PRIVATE -DELPP_NO_DEFAULT_LOG_FILE -DELPP_THREAD_SAFE -g -pthread -Wno-pragma-pack -Wno-pointer-arith -Wno-conversion-null -Wno-write-strings -Wno-format-security -fPIC -fms-extensions ${CLRHOSTDEF} -DPAL_STDCPP_COMPAT -DPLATFORM_UNIX -std=c++11)
  set_target_properties(ProcDumpProfiler PROPERTIES PREFIX "")

  target_include_directories(ProcDumpProfiler PUBLIC
                            "${profiler_INC}"
                            "${procdump_INC}"
                            /usr/include
                            )

  if(NOT APPLE AND CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
    target_include_directories(ProcDumpProfiler PUBLIC
                               /usr/include/aarch64-linux-gnu
                              )
  endif()

  add_custom_command(OUTPUT ProcDumpProfiler.o
                    COMMAND "${LD}" -r -b binary -o "${PROJECT_BINARY_DIR}/ProcDumpProfiler.o" ProcDumpProfiler.so
                    COMMENT "Packing ProcDumpProfiler.so into ProcDumpProfiler.o"
                    DEPENDS ProcDumpProfiler
                    )
endif()

#
# Configure files
#
configure_file(${procdump_INC}/ProcDumpVersion.h.in ${PROJECT_BINARY_DIR}/ProcDumpVersion.h)
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  configure_file(dist/DEBIAN.in/control.in DEBIANcontrol)
  configure_file(dist/SPECS.in/spec.in SPECS.spec)
endif()

#
# Make ProcDump
#
if(APPLE)
    # Create universal binary
    set(CMAKE_OSX_ARCHITECTURES "x86_64;arm64")
endif()

if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  message(STATUS "Building for Linux")
  add_executable(procdump
                ${procdump_SRC}/CoreDumpWriter.cpp
                ${procdump_SRC}/DotnetHelpers.cpp
                ${procdump_SRC}/Events.cpp
                ${procdump_SRC}/GenHelpers.cpp
                ${procdump_SRC}/Handle.cpp
                ${procdump_SRC}/Logging.cpp
                ${procdump_SRC}/Monitor.cpp
                ${procdump_SRC}/Procdump.cpp
                ${procdump_SRC}/ProcDumpConfiguration.cpp
                ${procdump_SRC}/Process.cpp
                ${procdump_SRC}/ProfilerHelpers.cpp
                ${procdump_SRC}/Restrack.cpp
                ${sym_SOURCE_DIR}/bcc_proc.cpp
                ${sym_SOURCE_DIR}/bcc_syms.cc
                ${sym_SOURCE_DIR}/bcc_elf.cpp
                ${sym_SOURCE_DIR}/bcc_perf_map.cpp
                ${sym_SOURCE_DIR}/bcc_zip.cpp
                ${PROJECT_BINARY_DIR}/ProcDumpProfiler.o
                )
else()
  add_executable(procdump
                ${procdump_SRC}/CoreDumpWriter.cpp
                #${procdump_SRC}/DotnetHelpers.cpp
                ${procdump_SRC}/Events.cpp
                ${procdump_SRC}/GenHelpers.cpp
                ${procdump_SRC}/Handle.cpp
                ${procdump_SRC}/Logging.cpp
                ${procdump_SRC}/Monitor.cpp
                ${procdump_SRC}/Procdump.cpp
                ${procdump_SRC}/ProcDumpConfiguration.cpp
                ${procdump_SRC}/Process.cpp
                #${procdump_SRC}/ProfilerHelpers.cpp
                #${procdump_SRC}/Restrack.cpp
                #${sym_SOURCE_DIR}/bcc_proc.cpp
                #${sym_SOURCE_DIR}/bcc_syms.cc
                #${sym_SOURCE_DIR}/bcc_elf.cpp
                #${sym_SOURCE_DIR}/bcc_perf_map.cpp
                #${sym_SOURCE_DIR}/bcc_zip.cpp
                #${PROJECT_BINARY_DIR}/ProcDumpProfiler.o
                )
endif()

target_compile_options(procdump PRIVATE -g -pthread -fstack-protector-all -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 -Werror -D_GNU_SOURCE -std=c++11 -O2)

target_include_directories(procdump PUBLIC
                           ${procdump_INC}
                           ${PROJECT_BINARY_DIR}
                           /usr/include
                           ${sym_SOURCE_DIR}
                           ${procdump_ebpf_SOURCE_DIR}
                          )

if(NOT APPLE AND CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
  message(STATUS "Adding include path for aarch64: /usr/include/aarch64-linux-gnu")
  target_include_directories(procdump PUBLIC
                             /usr/include/aarch64-linux-gnu
                            )
endif()

if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  add_dependencies(procdump libbpf procdump_ebpf)
  target_link_libraries(procdump ${libbpf_SOURCE_DIR}/src/libbpf.a elf z pthread)
else()
  target_link_libraries(procdump z pthread)
endif()

#
# Copy integration test directory
#
add_custom_target(copy_integration_test_dir ALL
                  COMMAND ${CMAKE_COMMAND} -E copy_directory
                  ${CMAKE_SOURCE_DIR}/tests/integration ${CMAKE_BINARY_DIR}/tests/integration
                  COMMENT "Copying the tests/integration directory to the build directory"
                 )

#
# Make test application
#
add_executable(ProcDumpTestApplication
               ${procdump_Test}/ProcDumpTestApplication.c
              )

target_compile_options(ProcDumpTestApplication PRIVATE -g -pthread -std=gnu99 -fstack-protector-all -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2 -D_GNU_SOURCE -Werror -O2)

target_include_directories(ProcDumpTestApplication PUBLIC
                           /usr/include
                          )

target_link_libraries(ProcDumpTestApplication pthread)

#
# Make package(s)
#
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  message("Architecture: ${ARCHITECTURE}")
  add_custom_target(deb
                  COMMAND "${CMAKE_SOURCE_DIR}/makePackages.sh" "${CMAKE_SOURCE_DIR}" "${PROJECT_BINARY_DIR}" "${PACKAGE_NAME}" "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}" "0" "deb" "${ARCHITECTURE}"
                  DEPENDS "${CMAKE_SOURCE_DIR}/dist" "${PROJECT_BINARY_DIR}/procdump"
                  )

  add_custom_target(rpm
                  COMMAND "${CMAKE_SOURCE_DIR}/makePackages.sh" "${CMAKE_SOURCE_DIR}" "${PROJECT_BINARY_DIR}" "${PACKAGE_NAME}" "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}" "0" "rpm"
                  DEPENDS "${CMAKE_SOURCE_DIR}/dist" "${PROJECT_BINARY_DIR}/procdump"
                  )
else()
  add_custom_target(brew
                  COMMAND "${CMAKE_SOURCE_DIR}/makePackages.sh" "${CMAKE_SOURCE_DIR}" "${PROJECT_BINARY_DIR}" "${PACKAGE_NAME}" "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}" "0" "brew"
                  DEPENDS "${CMAKE_SOURCE_DIR}/dist" "${PROJECT_BINARY_DIR}/procdump"

=== debian/changelog ===
procdump (3.4.1-1~exp4) experimental; urgency=medium

  * Team upload (salsa.d.o/debian namespace).
  * B-D on bpftool/bpftrace

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 01 Apr 2025 15:13:02 +0200

procdump (3.4.1-1~exp3) experimental; urgency=medium

  * Team upload (salsa.d.o/debian namespace).
  * Add support for system libbpf from github proposed PR #266

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 01 Apr 2025 11:37:53 +0200

procdump (3.4.1-1~exp2) experimental; urgency=medium

  * Team upload (salsa.d.o/debian namespace).
  * Add cmake to B-D

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 01 Apr 2025 11:26:43 +0200

procdump (3.4.1-1~exp1) experimental; urgency=medium

  * Team upload (salsa.d.o/debian namespace).
  * New upstream version 3.4.1
  * Update copyright file for new release
  * Add patch to fix mips64el, uncommitted to series file
  * Drop upstream patches, cherry-pick merged 273 PR on top

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 01 Apr 2025 11:16:29 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: utils
 Priority: optional
 Maintainer: Anuradha Weeraman <anuradha@debian.org>
-Build-Depends: debhelper-compat (= 13), zlib1g-dev, clang
+Build-Depends: debhelper-compat (= 13), zlib1g-dev, bpftrace, bpftool, libbpf-dev, cmake, clang
 Standards-Version: 4.6.2
 Homepage: https://github.com/microsoft/ProcDump-for-Linux
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,7 @@
 #!/usr/bin/make -f
 
-export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=+fixfilepath
-DPKG_EXPORT_BUILDFLAGS=1
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=+all buildinfo=+path
+export DPKG_EXPORT_BUILDFLAGS=1
 
 include /usr/share/dpkg/buildflags.mk

=== debian/tests/control ===
Tests: run.sh
Depends: procdump, procps
Restrictions: needs-root
